#coding=utf-8
#DESC:Generated by MolFeat v4.0 : 2009/4/16 20:56:19

from molFeat import *
import time

def run():

	# from ligand coordinate (60.1, 109.8, 48.3)
	# to   ligand coordinate (60.9,  76.1, 52.6)


	# prepare
	#

	transpMode = getSurfaceTranspMode()

	setUndoOn(False)
	setSurfaceTranspMode(LOCAL_SORT)

	newScene()
	restorePresentationEntry(0)
	postRedraw()

	for i in range(20):
		time.sleep(0.1)

	FontSizeList    = [   8,  10,  12,  16,  18 ]
	ScreenWidthList = [ 300, 500, 700, 900, 1100 ]

	width, height = getSceneWindowSize()
	for i in range(len(FontSizeList)):
		if width < ScreenWidthList[i]:
			break

	fontSize = 18
	if i < len(FontSizeList):
		fontSize = FontSizeList[i]

	# ligand move
	#

	setCurrentMolecule([1])

	Step = 66
	Duration = 2.0

	for i in range(Step):
		f = i / float(Step-1)
		interpolateAtomTransform((60.1, 109.8, 48.3), (60.9,  76.1, 52.6), -120.0, f)
		postRedraw()
		time.sleep(Duration / float(Step))

	postRedraw()
	time.sleep(1)

	# scene move
	#

	Step = 100
	Duration = 4.0

	for i in range(Step):
		sceneRotate(0.3, 0.25, 0.0)
		sceneScale(0.7)
		postRedraw()
		time.sleep(Duration / float(Step))


	# surface transparent
	#

	setCurrentMolecule([2])
	setCurrentSurface([0])

	Step = 100
	Duration = 3.0

	for i in range(Step):
		setSurfaceTransparency(i * 0.75)
		postRedraw()
		time.sleep(Duration / float(Step))


	# merge molecule
	#

	setCurrentMolecule([0,1])
	mergeMolecule("Merged", True, True, False)

	postRedraw()
	time.sleep(1)


	# show stick and hydrogen bond  around ligand
	#

	selectAtom('ligand aroundres:4.0')

	setAtomShape(SHAPE_BALL_STICK, True)
	postRedraw()
	time.sleep(2)

	selectAtom('ligand')

	setAtomShape(SHAPE_BALL_STICK, True)
	postRedraw()
	time.sleep(2)

	selectAtom('ligand | ligand aroundres:4.0')

	setSpecialBondShape(SHAPE_HBOND, True)
	postRedraw()
	time.sleep(2)


	# create annotation
	#

	addAnnotation(SIMPLE)
	setSimpleAnnotationCoordByAtom(1, 2667)
	setAnnotationText('GDP')
	setAnnotationFont('Arial', fontSize, True, False, False, False)
	postRedraw()
	time.sleep(1)

	selectAtom('resno:120')
	addGroupNameAnnotations(0)
	setAnnotationFont('Arial', fontSize, True, False, False, False)
	postRedraw()
	time.sleep(1)

	selectAtom('resno:13')
	addGroupNameAnnotations(0)
	setSimpleAnnotationCoordByAtom(1, 188)
	setAnnotationFont('Arial', fontSize, True, False, False, False)
	postRedraw()
	time.sleep(1)

	selectAtom('resno:34')
	addGroupNameAnnotations(0)
	setAnnotationFont('Arial', fontSize, True, False, False, False)
	postRedraw()
	time.sleep(1)

	selectAtom('resno:30')
	addGroupNameAnnotations(0)
	setAnnotationFont('Arial', fontSize, True, False, False, False)
	postRedraw()
	time.sleep(1)


	# finalize
	#

	setUndoOn(True)
	setSurfaceTranspMode(transpMode)


if __name__ == '__main__':
	run()
